Crypto++ 8.0 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
Gzip Class Reference

GZIP Compression (RFC 1952) More...

Inheritance diagram for Gzip:

## Public Member Functions
| Gzip (BufferedTransformation *attachment=NULL, unsigned int deflateLevel=DEFAULT_DEFLATE_LEVEL, unsigned int log2WindowSize=DEFAULT_LOG2_WINDOW_SIZE, bool detectUncompressible=true)
| Construct a Gzip compressor. More...
| Gzip (const NameValuePairs &parameters, BufferedTransformation *attachment=NULL)
| Construct a Gzip compressor. More...
void | SetFiletime (word32 filetime)
void | SetFilename (const std::string &filename, bool throwOnEncodingError=false)
void | SetComment (const std::string &comment, bool throwOnEncodingError=false)
void | IsolatedInitialize (const NameValuePairs &parameters)
| Initialize or reinitialize this object, without signal propagation. More...
Public Member Functions inherited from Deflator
| Deflator (BufferedTransformation *attachment=NULL, int deflateLevel=DEFAULT_DEFLATE_LEVEL, int log2WindowSize=DEFAULT_LOG2_WINDOW_SIZE, bool detectUncompressible=true)
| Construct a Deflator compressor. More...
| Deflator (const NameValuePairs &parameters, BufferedTransformation *attachment=NULL)
| Construct a Deflator compressor. More...
void | SetDeflateLevel (int deflateLevel)
| Sets the deflation level. More...
int | GetDeflateLevel () const
| Retrieves the deflation level. More...
int | GetLog2WindowSize () const
| Retrieves the window size. More...
void | IsolatedInitialize (const NameValuePairs &parameters)
| Initialize or reinitialize this object, without signal propagation. More...
size_t | Put2 (const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing. More...
bool | IsolatedFlush (bool hardFlush, bool blocking)
| Flushes data buffered by this object, without signal propagation. More...
Public Member Functions inherited from LowFirstBitWriter
| LowFirstBitWriter (BufferedTransformation *attachment)
| Construct a LowFirstBitWriter. More...
void | PutBits (unsigned long value, unsigned int length)
void | FlushBitBuffer ()
void | ClearBitBuffer ()
void | StartCounting ()
unsigned long | FinishCounting ()
Public Member Functions inherited from Filter
size_t | TransferTo2 (BufferedTransformation &target, lword &transferBytes, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer bytes from this object to another BufferedTransformation. More...
size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true) const
| Copy bytes from this object to another BufferedTransformation. More...
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| Initialize or reinitialize this object, with signal propagation. More...
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output, with signal propagation. More...
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| Marks the end of a series of messages, with signal propagation. More...
| Filter (BufferedTransformation *attachment=NULL)
| Construct a Filter. More...
bool | Attachable ()
| Determine if attachable. More...
BufferedTransformation * | AttachedTransformation ()
| Retrieve attached transformation. More...
const BufferedTransformation * | AttachedTransformation () const
| Retrieve attached transformation. More...
void | Detach (BufferedTransformation *newAttachment=NULL)
| Replace an attached transformation. More...
Public Member Functions inherited from BufferedTransformation
| BufferedTransformation ()
| Construct a BufferedTransformation.
BufferedTransformation & | Ref ()
| Provides a reference to this object. More...
size_t | Put (byte inByte, bool blocking=true)
| Input a byte for processing. More...
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing. More...
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing. More...
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing. More...
virtual byte * | CreatePutSpace (size_t &size)
| Request space which can be written into by the caller. More...
virtual bool | CanModifyInput () const
| Determines whether input can be modified by the callee. More...
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee. More...
bool | MessageEnd (int propagation=-1, bool blocking=true)
| Signals the end of messages to the object. More...
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee. More...
unsigned int | GetMaxWaitObjectCount () const
| Retrieves the maximum number of waitable objects.
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| Retrieves waitable objects. More...
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
| Marks the end of a series of messages, without signal propagation. More...
virtual void | SetAutoSignalPropagation (int propagation)
| Set propagation of automatically generated and transferred signals. More...
virtual int | GetAutoSignalPropagation () const
| Retrieve automatic signal propagation value. More...
virtual lword | MaxRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual bool | AnyRetrievable () const
| Determines whether bytes are ready for retrieval. More...
virtual size_t | Get (byte &outByte)
| Retrieve a 8-bit byte. More...
virtual size_t | Get (byte *outString, size_t getMax)
| Retrieve a block of bytes. More...
virtual size_t | Peek (byte &outByte) const
| Peek a 8-bit byte. More...
virtual size_t | Peek (byte *outString, size_t peekMax) const
| Peek a block of bytes. More...
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 16-bit word. More...
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 32-bit word. More...
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 16-bit word. More...
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 32-bit word. More...
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL)
| move transferMax bytes of the buffered output to target as input More...
virtual lword | Skip (lword skipMax=LWORD_MAX)
| Discard skipMax bytes from the output buffer. More...
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| copy copyMax bytes of the buffered output to target as input More...
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object using an index to another BufferedTransformation. More...
virtual lword | TotalBytesRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual unsigned int | NumberOfMessages () const
| Provides the number of meesages processed by this object. More...
virtual bool | AnyMessages () const
| Determines if any messages are available for retrieval. More...
virtual bool | GetNextMessage ()
| Start retrieving the next message. More...
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| Skip a number of meessages. More...
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL)
| Transfer messages from this object to another BufferedTransformation. More...
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual void | SkipAll ()
| Skip all messages in the series.
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL)
| Transfer all bytes from this object to another BufferedTransformation. More...
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual bool | GetNextMessageSeries ()
| Retrieve the next message in a series. More...
virtual unsigned int | NumberOfMessagesInThisSeries () const
| Provides the number of messages in a series. More...
virtual unsigned int | NumberOfMessageSeries () const
| Provides the number of messages in a series. More...
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer messages from this object to another BufferedTransformation. More...
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer all bytes from this object to another BufferedTransformation. More...
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
| Input a byte for processing on a channel. More...
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing on a channel. More...
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee on a channel. More...
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing on a channel. More...
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing on a channel. More...
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Signal the end of a message. More...
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
| Request space which can be written into by the caller. More...
virtual size_t | ChannelPut2 (const std::string &channel, const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing on a channel. More...
virtual size_t | ChannelPutModifiable2 (const std::string &channel, byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee on a channel. More...
virtual bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output on a channel. More...
virtual bool | ChannelMessageSeriesEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Marks the end of a series of messages on a channel. More...
virtual void | SetRetrievalChannel (const std::string &channel)
| Sets the default retrieval channel. More...
virtual void | Attach (BufferedTransformation *newAttachment)
| Add newAttachment to the end of attachment chain. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from Waitable
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| Wait on this object. More...

## Additional Inherited Members
Public Types inherited from Deflator
enum | { MIN_DEFLATE_LEVEL = 0, DEFAULT_DEFLATE_LEVEL = 6, MAX_DEFLATE_LEVEL = 9 }
| Deflate level as enumerated values. More...
enum | { MIN_LOG2_WINDOW_SIZE = 9, DEFAULT_LOG2_WINDOW_SIZE = 15, MAX_LOG2_WINDOW_SIZE = 15 }
| Windows size as enumerated values. More...

## Detailed Description

GZIP Compression (RFC 1952)

Definition at line 17 of file gzip.h.

## Constructor & Destructor Documentation

## ◆ Gzip() [1/2]

Gzip::Gzip | ( | BufferedTransformation * | attachment = `NULL`,
|  | unsigned int | deflateLevel = `DEFAULT_DEFLATE_LEVEL`,
|  | unsigned int | log2WindowSize = `DEFAULT_LOG2_WINDOW_SIZE`,
|  | bool | detectUncompressible = `true`
| ) |  |
| inline

Construct a Gzip compressor.

Parameters

  attachment | an attached transformation
  deflateLevel | the deflate level
  log2WindowSize | the window size
  detectUncompressible | flag to detect if data is compressible

detectUncompressible makes it faster to process uncompressible files, but if a file has both compressible and uncompressible parts, it may fail to compress some of the compressible parts.

Definition at line 28 of file gzip.h.

## ◆ Gzip() [2/2]

Gzip::Gzip | ( | const NameValuePairs & | parameters,
|  | BufferedTransformation * | attachment = `NULL`
| ) |  |
| inline

Construct a Gzip compressor.

Parameters

  parameters | a set of NameValuePairs to initialize this object
  attachment | an attached transformation

Possible parameter names: Log2WindowSize, DeflateLevel, DetectUncompressible

Definition at line 35 of file gzip.h.

## Member Function Documentation

## ◆ SetFiletime()

void Gzip::SetFiletime | ( | word32 | filetime | ) |
| inline

Parameters

  filetime | the filetime to set in the header. The application is responsible for setting it.

Definition at line 42 of file gzip.h.

## ◆ SetFilename()

void Gzip::SetFilename | ( | const std::string & | filename,
|  | bool | throwOnEncodingError = `false`
| ) |  |

Parameters

  filename | the original filename to set in the header. The application is responsible for setting it. RFC 1952 requires a ISO/IEC 8859-1 encoding.
  throwOnEncodingError | if throwOnEncodingError is true, then the filename is checked to ensure it is ISO/IEC 8859-1 encoded. If the filename does not adhere to ISO/IEC 8859-1, then a InvalidDataFormat is thrown. If throwOnEncodingError is false then the filename is not checked.

Definition at line 89 of file gzip.cpp.

## ◆ SetComment()

void Gzip::SetComment | ( | const std::string & | comment,
|  | bool | throwOnEncodingError = `false`
| ) |  |

Parameters

  comment | the comment to set in the header. The application is responsible for setting it. RFC 1952 requires a ISO/IEC 8859-1 encoding.
  throwOnEncodingError | if throwOnEncodingError is true, then the comment is checked to ensure it is ISO/IEC 8859-1 encoded. If the comment does not adhere to ISO/IEC 8859-1, then a InvalidDataFormat is thrown. If throwOnEncodingError is false then the comment is not checked.

Definition at line 75 of file gzip.cpp.

## ◆ IsolatedInitialize()

void Gzip::IsolatedInitialize | ( | const NameValuePairs & | parameters | ) |
| virtual

Initialize or reinitialize this object, without signal propagation.

Parameters

  parameters | a set of NameValuePairs to initialize this object

Exceptions

  NotImplemented |

IsolatedInitialize() is used to initialize or reinitialize an object using a variable number of arbitrarily typed arguments. The function avoids the need for multiple constructors providing all possible combintations of configurable parameters.

IsolatedInitialize() does not call Initialize() on attached transformations. If initialization should be propagated, then use the Initialize() function.

If a derived class does not override IsolatedInitialize(), then the base class throws NotImplemented.

Reimplemented from BufferedTransformation.

Definition at line 15 of file gzip.cpp.

The documentation for this class was generated from the following files:

- gzip.h
- gzip.cpp